## targetcli 2.1

=== Makefile ===
NAME = targetcli
GIT_BRANCH = $$(git branch | grep \* | tr -d \*)
VERSION = $$(basename $$(git describe --tags | tr - .))

all:
	@echo "Usage:"
	@echo
	@echo "  make deb         - Builds debian packages."
	@echo "  make rpm         - Builds rpm packages."
	@echo "  make release     - Generates the release tarball."
	@echo
	@echo "  make clean       - Cleanup the local repository build files."
	@echo "  make cleanall    - Also remove dist/*"

clean:
	@rm -fv ${NAME}/*.pyc ${NAME}/*.html
	@rm -frv doc
	@rm -frv ${NAME}.egg-info MANIFEST build
	@rm -frv debian/tmp
	@rm -fv build-stamp
	@rm -fv dpkg-buildpackage.log dpkg-buildpackage.version
	@rm -frv *.rpm
	@rm -fv debian/files debian/*.log debian/*.substvars
	@rm -frv debian/${NAME}-doc/ debian/python2.5-${NAME}/
	@rm -frv debian/python2.6-${NAME}/ debian/python-${NAME}/
	@rm -frv results
	@rm -fv rpm/*.spec *.spec rpm/sed* sed*
	@rm -frv ${NAME}-*
	@rm -frv *.rpm warn${NAME}.txt build${NAME}
	@rm -fv debian/*.debhelper.log debian/*.debhelper debian/*.substvars debian/files
	@rm -fvr debian/${NAME}-frozen/ debian/${NAME}-python2.5/
	@rm -fvr debian/${NAME}-python2.6/ debian/${NAME}/ debian/${NAME}-doc/
	@rm -frv log/
	@echo "Finished cleanup."

cleanall: clean
	@rm -frv dist

release: build/release-stamp
build/release-stamp:
	@mkdir -p build
	@echo "Exporting the repository files..."
	@git archive ${GIT_BRANCH} --prefix ${NAME}-${VERSION}/ \
		| (cd build; tar xfp -)
	@echo "Cleaning up the target tree..."
	@rm -f build/${NAME}-${VERSION}/Makefile
	@rm -f build/${NAME}-${VERSION}/.gitignore
	@rm -rf build/${NAME}-${VERSION}/bin
	@echo "Fixing version string..."
	@sed -i "s/__version__ = .*/__version__ = '${VERSION}'/g" \
		build/${NAME}-${VERSION}/${NAME}/__init__.py
	@echo "Generating rpm specfile from template..."
	@cd build/${NAME}-${VERSION}; \
		for spectmpl in rpm/*.spec.tmpl; do \
			sed -i "s/Version:\( *\).*/Version:\1${VERSION}/g" $${spectmpl}; \
			mv $${spectmpl} $$(basename $${spectmpl} .tmpl); \
		done; \
		rmdir rpm
	@echo "Generating rpm changelog..."
	@( \
		version=$$(basename $$(git describe HEAD --tags | tr - .)); \
		author=$$(git show HEAD --format="format:%an <%ae>" -s); \
		date=$$(git show HEAD --format="format:%ad" -s \
			| awk '{print $$1,$$2,$$3,$$5}'); \
		hash=$$(git show HEAD --format="format:%H" -s); \
	   	echo '* '"$${date} $${author} $${version}-1"; \
		echo "  - Generated from git commit $${hash}."; \
	) >> $$(ls build/${NAME}-${VERSION}/*.spec)
	@echo "Generating debian changelog..."
	@( \
		version=$$(basename $$(git describe HEAD --tags | tr - .)); \
		author=$$(git show HEAD --format="format:%an <%ae>" -s); \
		date=$$(git show HEAD --format="format:%aD" -s); \
		day=$$(git show HEAD --format='format:%ai' -s \
			| awk '{print $$1}' \
			| awk -F '-' '{print $$3}' | sed 's/^0/ /g'); \
		date=$$(echo $${date} \
			| awk '{print $$1, "'"$${day}"'", $$3, $$4, $$5, $$6}'); \
		hash=$$(git show HEAD --format="format:%H" -s); \
	   	echo "${NAME} ($${version}) unstable; urgency=low"; \
		echo; \
		echo "  * Generated from git commit $${hash}."; \
		echo; \
		echo " -- $${author}  $${date}"; \
		echo; \
	) > build/${NAME}-${VERSION}/debian/changelog
	@find build/${NAME}-${VERSION}/ -exec \
		touch -t $$(date -d @$$(git show -s --format="format:%at") \
			+"%Y%m%d%H%M.%S") {} \;
	@mkdir -p dist
	@cd build; tar -c --owner=0 --group=0 --numeric-owner \
		--format=gnu -b20 --quoting-style=escape \
		-f ../dist/${NAME}-${VERSION}.tar \
		$$(find ${NAME}-${VERSION} -type f | sort)
	@gzip -6 -n dist/${NAME}-${VERSION}.tar
	@echo "Generated release tarball:"
	@echo "    $$(ls dist/${NAME}-${VERSION}.tar.gz)"
	@touch build/release-stamp

deb: release build/deb-stamp
build/deb-stamp:
	@echo "Building debian packages..."
	@cd build/${NAME}-${VERSION}; \
		dpkg-buildpackage -rfakeroot -us -uc
	@mv build/*_${VERSION}_*.deb dist/
	@echo "Generated debian packages:"
	@for pkg in $$(ls dist/*_${VERSION}_*.deb); do echo "  $${pkg}"; done
	@touch build/deb-stamp

rpm: release build/rpm-stamp
build/rpm-stamp:
	@echo "Building rpm packages..."
	@mkdir -p build/rpm
	@build=$$(pwd)/build/rpm; dist=$$(pwd)/dist/; rpmbuild \
		--define "_topdir $${build}" --define "_sourcedir $${dist}" \
		--define "_rpmdir $${build}" --define "_buildir $${build}" \
		--define "_srcrpmdir $${build}" -ba build/${NAME}-${VERSION}/*.spec
	@mv build/rpm/*-${VERSION}*.src.rpm dist/
	@mv build/rpm/*/*-${VERSION}*.rpm dist/
	@echo "Generated rpm packages:"
	@for pkg in $$(ls dist/*-${VERSION}*.rpm); do echo "  $${pkg}"; done
	@touch build/rpm-stamp

## targetcli 2.0rc1

=== debian/changelog ===
targetcli (2.0rc1-2) unstable; urgency=low

  * Upload to unstable 

 -- Ritesh Raj Sarraf <rrs@debian.org>  Mon, 12 Dec 2011 17:02:22 +0530

targetcli (2.0rc1-1) experimental; urgency=low

  * Initial release. (Closes: #627107)

 -- Ritesh Raj Sarraf <rrs@debian.org>  Fri, 02 Dec 2011 01:00:13 +0530

=== debian/control ===
Source: targetcli
Section: python
Priority: optional
Maintainer: Ritesh Raj Sarraf <rrs@debian.org>
Build-Depends: debhelper(>= 7.0.50~), python(>= 2.6.6-3~), python-rtslib, python-configshell, lio-utils
Standards-Version: 3.9.2
Homepage: http://www.risingtidesystems.com/git/?p=targetcli.git;a=summary
Vcs-Git: git://git.debian.org/git/linux-target/targetcli.git
Vcs-Browser: http://git.debian.org/?p=linux-target/targetcli.git

Package: targetcli
Architecture: all
Depends: ${python:Depends}, ${misc:Depends}, python-configshell, lio-utils, python-rtslib
Provides: ${python:Provides}
Description: administration tool for managing LIO core target
 targetcli is an administration tool for managing the LIO storage targets
 using the Linux kernel's core target and compatible target fabric modules
 .
 It is part of the Linux Kernel SCSI Target's userspace tools

## targetcli 2.1

=== debian/changelog ===
targetcli (2.1-1) unstable; urgency=low

  * [a12a7e9] Correct the Section in which the software falls, i.e. net.
    Thanks to Axel Beckert (Closes: #702568)
  * [cee4929] Add README.source
  * [bbde80b] Imported Upstream version 2.1 (Closes: #718324)
  * [c47d667] Switch license to Apache 2.0
  * [762b71a] Update Vcs links

 -- Ritesh Raj Sarraf <rrs@debian.org>  Sun, 04 Aug 2013 00:16:10 +0530

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,12 @@
 Source: targetcli
-Section: python
+Section: net
 Priority: optional
 Maintainer: Ritesh Raj Sarraf <rrs@debian.org>
 Build-Depends: debhelper(>= 7.0.50~), python(>= 2.6.6-3~), python-rtslib, python-configshell, lio-utils
 Standards-Version: 3.9.2
 Homepage: http://www.risingtidesystems.com/git/?p=targetcli.git;a=summary
-Vcs-Git: git://git.debian.org/git/linux-target/targetcli.git
-Vcs-Browser: http://git.debian.org/?p=linux-target/targetcli.git
+Vcs-Git: git://anonscm.debian.org/linux-target/targetcli.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=linux-target/targetcli.git
 
 Package: targetcli
 Architecture: all

=== debian/rules ===
#!/usr/bin/make -f

build_dir   = build
install_dir = debian/targetcli


%:
	dh $@ --with python2

override_dh_auto_clean:
	# manually clean any *.pyc files
	rm -rf targetcli/*.pyc

override_dh_auto_build:
	python setup.py build --build-base $(build_dir) 

override_dh_auto_install:
	python setup.py install --prefix=/usr --no-compile  \
		--install-layout=deb --root=$(CURDIR)/$(install_dir)

## targetcli 2.1.fb43

=== debian/changelog ===
targetcli (2:2.1.fb43-1) experimental; urgency=medium

  * WARNING: Only for testing
  * [992cc12] Imported Upstream version 2.1.fb43
  * [08a392b] Add dependency to rtslib-fb
  * [b871f81] Add python-setuptools to build-depends
  * [603ba42] Drop target.init file
  * [98c8733] Update path for manpage

 -- Ritesh Raj Sarraf <rrs@debian.org>  Mon, 01 Aug 2016 17:07:32 +0530

targetcli (1:3.0~pre4.1~ga55d018-3) unstable; urgency=medium

  * [7ea95e3] Fix (un)loading of kernel modules
  * [a9b9106] Fix Vcs and Homepage URLs
  * [2dbdc41] Add dh-python to build-deps
  * [7b2d846] Secure directory permissions to safeguard sensitive
    information. Thanks to Christoph Scheurer (Closes: #824878)

 -- Ritesh Raj Sarraf <rrs@debian.org>  Mon, 13 Jun 2016 18:37:54 +0530

targetcli (1:3.0~pre4.1~ga55d018-2) unstable; urgency=medium

  * [8bcd229] Update README.source
  * Upload to Unstable

 -- Ritesh Raj Sarraf <rrs@debian.org>  Thu, 30 Apr 2015 16:39:28 +0530

targetcli (1:3.0~pre4.1~ga55d018-1) experimental; urgency=medium

  * [4195fcc] Imported Upstream version 3.0~pre4.1~ga55d018

 -- Ritesh Raj Sarraf <rrs@debian.org>  Wed, 17 Dec 2014 17:56:05 +0530

targetcli (3.0+git0.7e32595e-2) unstable; urgency=medium

  * Upload to Unstable 

 -- Ritesh Raj Sarraf <rrs@debian.org>  Sun, 28 Sep 2014 16:22:30 +0530

targetcli (3.0+git0.7e32595e-1) experimental; urgency=medium

  * [e3ada7d] Imported Upstream version 3.0+git0.7e32595e
  * [b19857f] Add lio-utils to Conflicts and add versioned
    (build) dependency on rtslib
  * [7c24d56] Add python-pyparsing to build-dep
  * [435d60e] Add python-prettytable to build-dep
  * [d41ef03] Update copyright
  * [cf6a045] Use upstream's init script
  * [89cbcb5] Add targetcli manpage

 -- Ritesh Raj Sarraf <rrs@debian.org>  Sat, 20 Sep 2014 16:47:57 +0530

=== debian/control ===
Source: targetcli
Section: net
Priority: optional
Maintainer: Ritesh Raj Sarraf <rrs@debian.org>
Build-Depends: debhelper(>= 7.0.50~), python(>= 2.6.6-3~), python-rtslib-fb, python-configshell, python-pyparsing, python-prettytable, dh-python, python-setuptools
Standards-Version: 3.9.2
Homepage: https://github.com/Datera/targetcli
Vcs-Git: https://anonscm.debian.org/git/linux-target/targetcli.git
Vcs-Browser: https://anonscm.debian.org/gitweb/?p=linux-target/targetcli.git

Package: targetcli
Architecture: all
Depends: ${python:Depends}, ${misc:Depends}, python-configshell, python-rtslib-fb
Provides: ${python:Provides}
Conflicts: lio-utils
Description: administration tool for managing LIO core target
 targetcli is an administration tool for managing the LIO storage targets
 using the Linux kernel's core target and compatible target fabric modules
 .
 It is part of the Linux Kernel SCSI Target's userspace tools

=== debian/rules ===
--- 
+++ 
@@ -13,7 +13,10 @@
 
 override_dh_auto_build:
 	python setup.py build --build-base $(build_dir) 
-
+	
 override_dh_auto_install:
 	python setup.py install --prefix=/usr --no-compile  \
 		--install-layout=deb --root=$(CURDIR)/$(install_dir)
+
+override_dh_installinit:
+	dh_installinit --name target

## targetcli 3.0~pre4.1~ga55d018

=== debian/control ===
Source: targetcli
Section: net
Priority: optional
Maintainer: Ritesh Raj Sarraf <rrs@debian.org>
Build-Depends: debhelper(>= 7.0.50~), python(>= 2.6.6-3~), python-rtslib (>= 3.0~), python-configshell, python-pyparsing, python-prettytable
Standards-Version: 3.9.2
Homepage: http://www.risingtidesystems.com/git/?p=targetcli.git;a=summary
Vcs-Git: git://anonscm.debian.org/linux-target/targetcli.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=linux-target/targetcli.git

Package: targetcli
Architecture: all
Depends: ${python:Depends}, ${misc:Depends}, python-configshell, python-rtslib (>= 3.0~)
Provides: ${python:Provides}
Conflicts: lio-utils
Description: administration tool for managing LIO core target
 targetcli is an administration tool for managing the LIO storage targets
 using the Linux kernel's core target and compatible target fabric modules
 .
 It is part of the Linux Kernel SCSI Target's userspace tools

=== debian/rules ===
--- 
+++ 
@@ -14,6 +14,9 @@
 override_dh_auto_build:
 	python setup.py build --build-base $(build_dir) 
 	
+	# Use upstream's init script
+	test -f scripts/target.init && cp scripts/target.init debian/target.init
+
 override_dh_auto_install:
 	python setup.py install --prefix=/usr --no-compile  \
 		--install-layout=deb --root=$(CURDIR)/$(install_dir)

=== debian/watch ===
# currently maintained in git.
# upstream plans to do tarball releases soon

## targetcli 3.0%2bgit0.7e32595e

=== Makefile ===
--- 
+++ 
@@ -1,11 +1,35 @@
+# This file is part of LIO(tm).
+# Copyright (c) 2011-2014 by Datera, Inc
+#
+# Licensed under the Apache License, Version 2.0 (the "License"); you may
+# not use this file except in compliance with the License. You may obtain
+# a copy of the License at
+#
+#     http://www.apache.org/licenses/LICENSE-2.0
+#
+#     Unless required by applicable law or agreed to in writing, software
+#     distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
+#     WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
+#     License for the specific language governing permissions and limitations
+#     under the License.
+#
+
 NAME = targetcli
 GIT_BRANCH = $$(git branch | grep \* | tr -d \*)
-VERSION = $$(basename $$(git describe --tags | tr - .))
+GIT_DESC = $$(basename $$(git describe --tags | grep -o '[0-9].*$$'))
+GIT_LAST_TAG = $$(git describe --tags --abbrev=0 | grep -o '[0-9].*$$')
+GIT_PKG_TAG = $$(echo $(GIT_LAST_TAG) | tr - \~)
+VERSION = $$(echo $(GIT_DESC) | sed s/^$(GIT_LAST_TAG)/$(GIT_PKG_TAG)/)
+
+version:
+	@echo $(VERSION)
 
 all:
 	@echo "Usage:"
 	@echo
 	@echo "  make deb         - Builds debian packages."
+	@echo "  make debinstall  - Builds and installs debian packages."
+	@echo "                     (requires sudo access)"
 	@echo "  make rpm         - Builds rpm packages."
 	@echo "  make release     - Generates the release tarball."
 	@echo
@@ -13,8 +37,7 @@
 	@echo "  make cleanall    - Also remove dist/*"
 
 clean:
-	@rm -fv ${NAME}/*.pyc ${NAME}/*.html
-	@rm -frv doc
+	@rm -frv ${NAME}/*.html
 	@rm -frv ${NAME}.egg-info MANIFEST build
 	@rm -frv debian/tmp
 	@rm -fv build-stamp
@@ -31,6 +54,10 @@
 	@rm -fvr debian/${NAME}-frozen/ debian/${NAME}-python2.5/
 	@rm -fvr debian/${NAME}-python2.6/ debian/${NAME}/ debian/${NAME}-doc/
 	@rm -frv log/
+	@find . -name *.swp -exec rm -v {} \;
+	@find . -name *.pyc -exec rm -vf {} \;
+	@find . -name *~ -exec rm -v {} \;
+	@find . -name \#*\# -exec rm -v {} \;
 	@echo "Finished cleanup."
 
 cleanall: clean
@@ -42,6 +69,7 @@
 	@echo "Exporting the repository files..."
 	@git archive ${GIT_BRANCH} --prefix ${NAME}-${VERSION}/ \
 		| (cd build; tar xfp -)
+	@cp -pr debian/ build/${NAME}-${VERSION}
 	@echo "Cleaning up the target tree..."
 	@rm -f build/${NAME}-${VERSION}/Makefile
 	@rm -f build/${NAME}-${VERSION}/.gitignore
@@ -58,7 +86,7 @@
 		rmdir rpm
 	@echo "Generating rpm changelog..."
 	@( \
-		version=$$(basename $$(git describe HEAD --tags | tr - .)); \
+		version=$(VERSION); \
 		author=$$(git show HEAD --format="format:%an <%ae>" -s); \
 		date=$$(git show HEAD --format="format:%ad" -s \
 			| awk '{print $$1,$$2,$$3,$$5}'); \
@@ -68,7 +96,7 @@
 	) >> $$(ls build/${NAME}-${VERSION}/*.spec)
 	@echo "Generating debian changelog..."
 	@( \
-		version=$$(basename $$(git describe HEAD --tags | tr - .)); \
+		version=$(VERSION); \
 		author=$$(git show HEAD --format="format:%an <%ae>" -s); \
 		date=$$(git show HEAD --format="format:%aD" -s); \
 		day=$$(git show HEAD --format='format:%ai' -s \
@@ -107,6 +135,10 @@
 	@for pkg in $$(ls dist/*_${VERSION}_*.deb); do echo "  $${pkg}"; done
 	@touch build/deb-stamp
 
+debinstall: deb
+	@echo "Installing $$(ls dist/*_${VERSION}_*.deb)"
+	@sudo dpkg -i $$(ls dist/*_${VERSION}_*.deb)
+
 rpm: release build/rpm-stamp
 build/rpm-stamp:
 	@echo "Building rpm packages..."
